#!/user/local/bin/ruby -Ks
def showHelp; scrName = File::basename($0.gsub(/\\/, '/'));
puts <<"================================================"
Tv: LDOCE  3 /LDAE  2 ł EBStudio p̓t@C쐬
\: ruby -Ks #{scrName} [<option>] <inDir> [<outDir>]
  <option>
    -e      (English)  LDOCE ̕ϊ (l)
    -a      (American) LDAE ̕ϊ
  <inDir>   BASE.DB t@ĈfBNg
  <outDir>  o̓fBNg (wȂȂJgfBNg)
:
* LDOCE/LDAE  CD-ROM (X:) 쐬
  ruby -Ks #{scrName} X:\\DATA\\DIC D:\\EPWING\\Longman
================================================
end
=begin
o: *.html  EBStudio ̓t@C
      *.ebs   EBStudio Ɗ`t@C
:
  v1.00 2003-05-30 by nomad
    J
  v1.10 2003-10-21 by nomad & Masashi Suzuto
    LDAE Ή (铡jɂ)
    Ot@CXNvgŃRs[悤ɕύX
: I[v\[X
=end

## 萔

DIC_LDOCE = 0    # Longman Dictionary of Contemporary English
DIC_LDAE  = 1    # Longman Dictionary of American English

Dics = [
  {
    'title'    => 'Longman Dictionary of Contemporary English',
    'outfile'  => 'LDOCE.html',
    'ebsfile'  => 'LDOCE.ebs',
    'dir'      => 'LDOCE',          # EPWING fBNg
  },
  {
    'title'    => 'Longman Dictionary of American English',
    'outfile'  => 'LDAE.html',
    'ebsfile'  => 'LDAE.ebs',
    'dir'      => 'LDAE',
  }
]

DATA_FNAME      = 'BASE.DB'            # ̓t@C
GAIZI_FNAME     = 'LDOCEGaiji.xml'     # Ot@C
GAIZI_MAP_FNAME = 'LDOCEGaijiMap.xml'  # O}bvt@C

## t@C̃Rs[
def copyFile(inPath, outPath)
  return if File::expand_path(inPath) == File::expand_path(outPath)

  inf = open(inPath, 'rb')
  outf = open(outPath, 'wb')
  outf.write(inf.read())

rescue => e
  STDERR.puts e.message
ensure
  inf.close if inf != nil
  outf.close if outf != nil
end

## Oϊe[u
Gaizi = {

  "\x93" => '"',        # &rdquo;
  "\x94" => '"',        # &ldquo;
  "\x97" => '--',       # &mdash; ??
  "\xa0" => ' ',        # &nbsp;
  "\xa2" => '&cent;',   # cent     #+ LDAE
  "\xa3" => '&pound;',
  "\xa8" => '&uml;',    # diaeresis
  "\xab" => '&frac12;', # 1/2        #+ LDAE
  "\xac" => '&frac14;', # 1/4        #+ LDAE
  "\xad" => '-',        # hard hyphen ??
  "\xb0" => '&deg;',    # degree   #+ LDAE
  "\xb7" => '&uml;',
  "\xba" => '&deg;C',   # Centigrade
  "\xbc" => '&frac12;', # 1/2
  "\xbe" => '&frac34;', # 3/4
  "\xbd" => '&cent;',   # cent     #+ LDAE
  "\xce" => '&#x014b;', #  (ng)

  "\xe0" => '&agrave;',
  "\xe2" => '&acirc;',
  "\xe6" => '&aelig;',
  "\xe7" => '&ccedil;',
  "\xe8" => '&egrave;',
  "\xe9" => '&eacute;',
  "\xea" => '&ecirc;',
  "\xeb" => '&euml;',
  "\xf1" => '&ntilde;',
  "\xf3" => '&frac34;', # 3/4        #+ LDAE
  "\xf4" => '&ocirc;',
  "\xf6" => '&ouml;',
  "\xf8" => '&deg;',    # degree   #+ LDAE

  "\xfc" => '&#xea07;', # <sup>n</sup>
  "\xfd" => '&sup2;'

}

## L̕ϊ
def convPronunciation(s)
  s.gsub!(/\\(\x10.)/) {
    key = $1
    case key
    when "\x10\xc1" then '&#x0252;' # d[o]g
    when "\x10\xf6" then '&#x028c;' # b[u]t
    when "\x10\xc6" then '&#x025c;' # b[i]rd
    when "\x10\xce" then '&#x014b;' # su[ng]
    when "\x10\x9a" then '&#x028c;' # [u]ncountable
    when "\x10\xa3" then '-'        #
    when "\x10\xdb" then '||'       #
    when "\x10\xe6" then '&aelig;'  # (short 1-19)
    when "\x10\x96" then ''         # errata (testimonial)

                                    #+ LDAE <<<
    when "\x10\xa7" then '&#xea0a;' # tu
    when "\x10\xae" then '&#x00e6;' # jn ae̊ԈႢ ??
    when "\x10\xc4" then '<i>d</i>' # C^bNd
    when "\x10\xd4" then '&#xea08;' # t_
    when "\x10\xf4" then '<i>t</i>' # C^bNt
    when "\x10\xf8" then '&#xea09;' # ܂ꉹ
                                    #+ LDAE >>>
    else
      x, = key.unpack('H*')
      STDERR.puts 'ERROR: \\x' + x
      '??\\x' + x
    end
  }

  s.gsub!(/\\(.)/) {
    key = $1
    if key =~ /[a-fh-z]/
      key
    else
      case key
      when 'g' then '&#x0261;' # [g]et
      when 'I' then '&#xea00;' # b[i]t
      when '{' then '&aelig;'  # c[a]t
      when 'U' then '&#x028a;' # p[u]t
      when '@' then '&#x0259;' # [a]bout
      when ':' then '&#x02d0;' # [:]
      when 'A' then '&#x0251;' # f[a]ther
      when "'" then '&#x2575;' # main stress
      when '"' then '&#x2577;' # secondary stress
      when 'S' then '&#x0283;' # [sh]ip
      when 'T' then '&#x03b8;' # [th]ing
      when 'Z' then '&#x0292;' # plea[s]ure
      when 'D' then '&#xea01;' # [th]en
      when 'F' then '&#xea02;' # ȗ\ schwa
      when 'X' then '&#xea05;' # stress shift 
      when '.' then '&middot;' # 
      when 'K' then '&#xea03;' # [i/indeterminate vowel] 
      when 'O' then '&#x0254;' # f[o]ur 
      when 'M' then '&#xea04;' # [u/indeterminate vowel] 
      when 'R' then '&#xea06;' # ȗ\ r (cornflower)

      # ȉA炭f[^~X
      when 'B' then 'b'            #
      when 'J' then 'j'            #
      when 'E' then '&#xea02;'     # (unfash[io]nable)
      when 'H' then '&#x2577;'     # ̑ 2 ANZg?
      when 'W' then '&#x2577;'     #
      when '2' then '&#x2577;'     #
      when '!' then '&#x2577;'     #
      when '/' then ''             # 
      when "\x10"  then ''         # (gerontological)

      when ' ', ',', ';'  then key
      else
        STDERR.puts 'ERROR: ' + key
        '??' + key
      end
    end
  }

  s
end

## I^O̒ǉ
##   e.g.  <b>...<i>.../A --> <b>...</b><i>...</i>
def addEtag(s)
  curTag = ''
  s.gsub(/<b>|<i>|<sup>|\/A/) { |tag|
    case tag
    when '/A'
      if curTag != ''
        newTag = curTag.sub(/</, '</')
        curTag = ''
        newTag
      else # error
        ''
      end
    else
      if curTag != ''
        newTag = curTag.sub(/</, '</') + tag
        curTag = tag
        newTag
      else
        curTag = tag
      end
    end
  }
end

## t@C (Í)
class LDOCE < File

  @@t = [ 0x89, 0xab, 0xcd, 0xef ]

  def initialize(fd, mode = "rb")
    super
    @count = 0
  end

  def getc
    c = super
    if c != nil
      c ^= @@t[@count & 3]
      @count += 1
    end
    c
  end

  def gets
    s = ''
    while c = self.getc
      s << c
      break if c == 0x0a   # sL 0x0a ̂܂
    end
    if s != ''
      s
    else
      nil
    end
  end

end

##
class EBSFile < File

  def printEBS(outDir, dicType)

    outDir = outDir.gsub(/\//, '\\') + '\\'
    title   = Dics[dicType]['title']
    dir     = Dics[dicType]['dir']
    outFile = Dics[dicType]['outfile']
    gaiziFile = GAIZI_FNAME
    gaiziMapFile = GAIZI_MAP_FNAME

    puts <<"--------"
InPath=#{outDir}
OutPath=#{outDir}
IndexFile=
Copyright=
GaijiFile=$(BASE)\\#{gaiziFile}
GaijiMapFile=$(BASE)\\#{gaiziMapFile}
EBType=0
WordSearchHyoki=1
WordSearchKana=1
EndWordSearchHyoki=1
EndWordSearchKana=1
KeywordSearch=1
ComplexSearch=0
topMenu=0
singleLine=1
kanaSep1=y
kanaSep2=z
makeFig=1
paraHdr=0
ruby=1
paraBr=0
subTitle=1
dfnStyle=0
srchUnit=0
linkChar=0
arrowCode=222A
eijiPronon=1
eijiPartOfSpeech=1
eijiBreak=1
leftMargin=1
indent=0
tableWidth=480
StopWord=a the
delBlank=1
delSym=1
delChars=
refAuto=0
titleWord=1
autoWord=0
HTagIndex=0
DTTagIndex=1
dispKeyInSelList=0
titleOrder=0
channel=0
nBit=0
sampLate=2
optMono=0
Size=10000;10000;4000;18000000;4000;100000;50000;500;500;10000
Book=#{title};#{dir};paT;_;_
Source=$(BASE)\\#{outFile};_;_;HTML;
--------
  end

end

###
class OutHTML < File

  def writeHeader(title = 'EBStudio p̓t@C')
    puts '<html>'
    puts '<head>'
    puts '<title>' + title + '</title>'
    puts '</head>'
    puts '<body>'
    puts '<dl>'
  end

  def writeFooter()
    puts '</dl>'
    puts '</body>'
    puts '</html>'
  end

end

## C
def main(dataF, outF)

  n = 0

  while line = dataF.gets
    line.chomp!
    next if line == ''  # s͓ǂݔ΂

    if line == '<FA>'   # ڏI
      outF.puts '</dd>'
      next
    elsif line =~ %r<^/2/B.*?[^\\]/A>    # o
      n += 1

if $DEBUG then break if n > 1000 end

      if n % 100 == 0
        STDERR.print n, "\r"
      end
      line = $& + '&break;' + $'   # ő؂}Ă
    end

    line.gsub!(/EMPTY>/, '')      # f[^~X
    line.gsub!(/\\&\\&\\&\\&\\&\\&/, '')      # f[^~X  #+ LDAE

    line.gsub!(/</, '&lt;')
    line.gsub!(/>/, '&gt;')

    # L
    line.gsub!(%r<\{r\\//L(.+?)/A\\/#SPEC:10:[05]\}>) {   #+ LDAE  0 -> [05]
      '/' + convPronunciation($1) + '/'
    }

    # \ (USAGE NOTE)
    if line =~ /^\/&TABLE:95%:3:\[\[99,0,0,0,3\|(.+?)\]#\[99,0,0,0,0\|/
      line = $1 + '<br>' + $'
      line.sub!(/\]\]&\//, '')

      line.gsub!(/\\\|/, '|') # \|
      line.gsub!(/\\\[/, '[')
      line.gsub!(/\\\]/, ']')
      line.gsub!(/\\n/, '<br>')
    end

    #+ LDAE <<<
    # \ (Spoken Phrases)
    if line =~ /^\/&TABLE:95%:3:\[\[99,0,0,0,0\|(.+?)\\n\\n/
      match = $1; after = $'
      line = match.sub(/^\/A\/\|/, '') + '<br>' + after

      line.sub!(/\]\]&\//, '')

      line.gsub!(/\\\|/, '|')
      line.gsub!(/\\\[/, '[')
      line.gsub!(/\\\]/, ']')
      line.gsub!(/\\n\\n/, '<br>')
      line.gsub!(/\\n/, '<br>')
    end
    #+ LDAE >>>

    line.gsub!(/\{B-1#(\d+)\}/) {  # `敪̊ې
      '(' + ($1.to_i + 1).to_s + ')'
    }
    line.gsub!(/\{B7\\?#1006\}/, '') # signposts   #+ LDAE  \\? ǉ
    line.gsub!(/\{B8\\?#1007\}/, '')               #+ LDAE  \\? ǉ

    line.gsub!(/\/!4!\//, '&times;') # ~ Usage hints #+ LDAE

    line.gsub!(/\\\//, '&slash;') # '\/' ϊĂ

    line.gsub!(%r</[02357]>, '')  # Fw

    line.gsub!(%r<(/C ?)noun>)         { $1 + 'n' }  # i
    line.gsub!(%r<(/C ?)verb>)         { $1 + 'v' }
    line.gsub!(%r<(/C ?)phrasal verb>) { $1 + 'phr v' }
    line.gsub!(%r<(/C ?)adjective>)    { $1 + 'adj' }
    line.gsub!(%r<(/C ?)adverb>)       { $1 + 'adv' }
    line.gsub!(%r<(/C ?)conjunction>)  { $1 + 'conj' }
    line.gsub!(%r<(/C ?)preposition>)  { $1 + 'prep' }
    line.gsub!(%r<(/C ?)pronoun>)      { $1 + 'pron' }

    line.gsub!(/(\[.*?)uncountable(.*?\])/)  { $1 + 'U' + $2 }
    line.gsub!(/(\[.*?)countable(.*?\])/)    { $1 + 'C' + $2 }
    line.gsub!(/(\[.*?)intransitive(.*?\])/) { $1 + 'I' + $2 }
    line.gsub!(/(\[.*?)transitive(.*?\])/)   { $1 + 'T' + $2 }

    line.gsub!(%r</K>, '<b>')     #+ LDAE

    line.gsub!(%r</B>, '<b>')     # tHgw
    line.gsub!(%r</C>, '<i>')
    line.gsub!(%r</D>, '<i>')     # ?? small capital
    line.gsub!(%r</E>, '<sup>')
    line = addEtag(line)

    line.gsub!(/\x10(.)/) {       # O
      c = $1
      if Gaizi.key?(c)
        Gaizi[c]
      else
        x, = c.unpack('H*')
        STDERR.puts 'ERROR Gaizi: ' + x
        '??\x10\x' + x
      end
    }

    line.gsub!(/\x0f\xde/, '')  #+ LDAE

    line.gsub!(/\\\./, '&middot;')

    line.gsub!(/&slash;/, '/')    # slash ߂

    next if line == ''

    if line =~ /&break;/
      head = $`; body = $'
      outF.puts '<dt>' + head + '</dt>'
      head =~ /<b>(.+)<\/b>/
      outF.puts '<key type="\L">' + $1 + '</key>'
      outF.puts '<dd>'
      outF.puts '<p>' + body + '</p>'
    else
      line.sub!(/^(-- <b>.+?<\/b>)/) {          # h`
         '<dfn>' + $1 + '</dfn>'
      }
      line.sub!(/^(<b>.+?<\/b>)(.+\bphr v\b)/) {  # 哮
         '<dfn>' + $1 + '</dfn>' + $2
      }
      outF.puts '<p>' + line + '</p>'
    end
  end

  STDERR.print n, "\n"

end

  # R}hC̏
  def ARGV.option
    return nil if self.empty?
    arg = self.shift
    if arg =~ /^-/
      return arg
    else
      self.unshift arg
      return nil
    end
  end

  begin
    dicType = DIC_LDOCE
    while option = ARGV.option
      case option
      when '-e'; dicType = DIC_LDOCE
      when '-a'; dicType = DIC_LDAE
      else
        raise 'ȃIvVł: ' + option
      end
    end
    raise DATA_FNAME + ' ̂fBNgw肵Ă' if ARGV.size < 1
  rescue => e
    STDERR.puts e.message
    showHelp()
    exit 1
  end

  scrDir = File::dirname($0.gsub(/\\/, '/'))
  scrDir.sub!(/\/$/, '')

  inDir = ARGV.shift.gsub(/\\/, '/')
  inDir.sub!(/\/$/, '')
  dataFName = inDir + '/' + DATA_FNAME
  outDir = if ARGV.size > 0 then ARGV.shift.gsub(/\\/, '/') else '.' end
  outDir.sub!(/\/$/, '')
  outFName = outDir + '/' + Dics[dicType]['outfile']

  STDERR.print "Jn: ", Time::now.strftime('%Y-%m-%d %X'), "\n"

  # o
  dataF = LDOCE::new(dataFName)
  outF = OutHTML::open(outFName, 'w')
  outF.writeHeader(Dics[dicType]['title'])

  $KCODE = 'NONE'
  main(dataF, outF)
  $KCODE = 'SJIS'

  outF.writeFooter
  outF.close
  dataF.close

  # Ɗ`t@Co
  EBSFile::open(outDir + '/' + Dics[dicType]['ebsfile'], 'w') { |f|
    f.printEBS(outDir, dicType)
  }

  # Ot@C̃Rs[
  copyFile(scrDir + '/' + GAIZI_FNAME, outDir + '/' + GAIZI_FNAME)
  copyFile(scrDir + '/' + GAIZI_MAP_FNAME, outDir + '/' + GAIZI_MAP_FNAME)

  STDERR.print "I: ", Time::now.strftime('%Y-%m-%d %X'), "\n"

exit
